	SUBROUTINE UMAT(STRESS,STATEV,DDSDDE,SSE,SPD,SCD,
     1 RPL,DDSDDT,DRPLDE,DRPLDT,STRAN,DSTRAN,
     2 TIME,DTIME,TEMP,DTEMP,PREDEF,DPRED,MATERL,NDI,NSHR,NTENS,
     3 NSTATV,PROPS,NPROPS,COORDS,DROT,PNEWDT,CELENT,
     4 DFGRD0,DFGRD1,NOEL,NPT,KSLAY,KSPT,KSTEP,KINC)
C
      INCLUDE 'ABA_PARAM.INC'
C
      CHARACTER*8 MATERL
      DIMENSION STRESS(NTENS),STATEV(NSTATV),
     1 DDSDDE(NTENS,NTENS),DDSDDT(NTENS),DRPLDE(NTENS),
     2 STRAN(NTENS),DSTRAN(NTENS),DFGRD0(3,3),DFGRD1(3,3),
     3 TIME(2),PREDEF(1),DPRED(1),PROPS(NPROPS),COORDS(3),DROT(3,3)
C
      DIMENSION sig(3,3)
      DIMENSION BH(6,6),BBTOT(3,3), BTOT(3,3), DFTOT(3,3)
      DIMENSION BBTOT0(3,3), BTOT0(3,3), DFTOT_0(3,3)
      DIMENSION Be(3,3), DFTOTINV(3,3), BeINV(3,3)
      DIMENSION CiTEMP(3,3), Ci(3,3), CiINV0(3,3), CiINV1(3,3)
      DIMENSION TAUNEQ(3,3), sigVISC(3,3), DDSDDE2(6,6)
      DIMENSION TAUVEC(3), DLTR(3), DPVEC(3,3), CALG(3,3)
C
C ----------------------------------------------------------------
C    sig   - EQ-CAUCHY STRESS
C    BH    - 4-TENSOR H ON VOIGTS FORM
C    BBTOT - TOTAL DEVIATORIC LEFT CAUCHY-GREEN TENSOR
C    BTOT  - TOTAL LEFT CAUCHY-GREEN TENSOR
C    DFTOT - TOTAL DEFORMATION GRADIENT
C    Be    - ELASTIC LEFT CAUCHY-GREEN STRAIN OF THE ELASTIC DEF GRADIENT
C    Ci    - INELASTIC RIGHT CAUCHY-GREEN STRAIN OF THE INELASTIC DEF GRADIENT
C    CiINV - INVERSE(Ci)
C    sigVISC - NEQ-CAUCHY STRESS
C    DDSDDE2(6,6) - NEQ PART OF THE TANGENT MODULUS
C ---------------------------------------------------------------- 
C
      PARAMETER(ZERO=0.D0, ONE=1.D0, TWO=2.D0, THREE=3.D0, FOUR=4.D0)
C
C ----------------------------------------------------------------

C ----------------------------------------------------------------
C
C    MATERIAL PROPERTIES
C
C     DNKT = N*K*T  DvN = v*N   DkTV = K*T/v    BmukT = mu/K*T
C     K := BOLTZMANNS CONSTANT  N := # POLYMER CHAINS / UNIT VOLUME
C     T := ABSOLUTE TEMPERATURE v := VOLUME PER SOLVENT MOLECULE
C     mu := CHEMICAL POTENTIAL   chi := DIMENSIONLESS ENERGY PARAMETER
C     NKT := INITIAL SHEAR MODULUS  BETA := SCALING CONSTANT OF NEQ-STRESS
C     VISCdev := DEVIATORIC VISCOSITY
C     VISCVOL := VOLUMETRIC VISCOSITY
C ----------------------------------------------------------------
C     
      DNKT=PROPS(1)
      DvN=PROPS(2)
      DkTV=DNKT/DvN
      chi=PROPS(3)
      VISCdev=PROPS(4)
      VISCvol=PROPS(5)
      BETA=PROPS(6)
C      
C     For use in coupled temp-disp analysis
c      BmukT=Bmukt0+TEMP
C
      BmukT=-0.04D0
C
C     CALCULATE INITIAL SWELLING
C      
      if (KSTEP.EQ.1 .AND. KINC.EQ.1) then
        CALL DJ0calc (DvN, chi, BmukT, DJ0c)
        STATEV(1)=DJ0c**(ONE/THREE)
        STATEV(2)=DJ0c**(ONE/THREE)
        STATEV(3)=DJ0c**(ONE/THREE)
      END IF      
      Dl01=STATEV(1)
      Dl02=STATEV(2)
      Dl03=STATEV(3)
C
C     CALCULATE TOTAL DEFORMATION GRADIENT AT END OF INCREMENT
C
      DFTOT(1,1) = DFGRD1(1,1)*Dl01
      DFTOT(1,2) = DFGRD1(1,2)*Dl02
      DFTOT(1,3) = DFGRD1(1,3)*Dl03
      DFTOT(2,1) = DFGRD1(2,1)*Dl01
      DFTOT(2,2) = DFGRD1(2,2)*Dl02
      DFTOT(2,3) = DFGRD1(2,3)*Dl03
      DFTOT(3,1) = DFGRD1(3,1)*Dl01
      DFTOT(3,2) = DFGRD1(3,2)*Dl02
      DFTOT(3,3) = DFGRD1(3,3)*Dl03
C
C     CALCULATE TOTAL DEFORMATION GRADIENT AT START OF INCREMENT
C      
      DFTOT_0(1,1) = DFGRD0(1,1)*Dl01
      DFTOT_0(1,2) = DFGRD0(1,2)*Dl02
      DFTOT_0(1,3) = DFGRD0(1,3)*Dl03
      DFTOT_0(2,1) = DFGRD0(2,1)*Dl01
      DFTOT_0(2,2) = DFGRD0(2,2)*Dl02
      DFTOT_0(2,3) = DFGRD0(2,3)*Dl03
      DFTOT_0(3,1) = DFGRD0(3,1)*Dl01
      DFTOT_0(3,2) = DFGRD0(3,2)*Dl02
      DFTOT_0(3,3) = DFGRD0(3,3)*Dl03
C
C     CALCULATE LEFT CAUCHY-GREEN STRAIN TENSOR AT END OF INCREMENT
C
      BTOT(1,1) = DFTOT(1,1)**TWO+DFTOT(1,2)**TWO+DFTOT(1,3)**TWO
      BTOT(1,2) = DFTOT(1,1)*DFTOT(2,1)+DFTOT(1,2)*DFTOT(2,2)+DFTOT(1,3)
     #*DFTOT(2,3)
      BTOT(1,3) = DFTOT(1,1)*DFTOT(3,1)+DFTOT(1,2)*DFTOT(3,2)+DFTOT(1,3)
     #*DFTOT(3,3)
      BTOT(2,1) = DFTOT(1,1)*DFTOT(2,1)+DFTOT(1,2)*DFTOT(2,2)+DFTOT(1,3)
     #*DFTOT(2,3)
      BTOT(2,2) = DFTOT(2,1)**TWO+DFTOT(2,2)**TWO+DFTOT(2,3)**TWO
      BTOT(2,3) = DFTOT(2,1)*DFTOT(3,1)+DFTOT(2,2)*DFTOT(3,2)+DFTOT(2,3)
     #*DFTOT(3,3)
      BTOT(3,1) = DFTOT(1,1)*DFTOT(3,1)+DFTOT(1,2)*DFTOT(3,2)+DFTOT(1,3)
     #*DFTOT(3,3)
      BTOT(3,2) = DFTOT(2,1)*DFTOT(3,1)+DFTOT(2,2)*DFTOT(3,2)+DFTOT(2,3)
     #*DFTOT(3,3)
      BTOT(3,3) = DFTOT(3,1)**TWO+DFTOT(3,2)**TWO+DFTOT(3,3)**TWO
C
C     CALCULATE LEFT CAUCHY-GREEN STRAIN TENSOR AT START OF INCREMENT  
C   
      BTOT0(1,1) = DFTOT_0(1,1)**2+DFTOT_0(1,2)**2+DFTOT_0(1,3)**2      
      BTOT0(1,2) = DFTOT_0(1,1)*DFTOT_0(2,1)+DFTOT_0(1,2)*DFTOT_0(2,2)
     #+DFTOT_0(1,3)
     #*DFTOT_0(2,3)    
      BTOT0(1,3) = DFTOT_0(1,1)*DFTOT_0(3,1)+DFTOT_0(1,2)*DFTOT_0(3,2)
     # +DFTOT_0(1,3)
     #*DFTOT_0(3,3)
      BTOT0(2,1) = DFTOT_0(1,1)*DFTOT_0(2,1)+DFTOT_0(1,2)*DFTOT_0(2,2)
     #+DFTOT_0(1,3)
     #*DFTOT_0(2,3)     
      BTOT0(2,2) = DFTOT_0(2,1)**2+DFTOT_0(2,2)**2+DFTOT_0(2,3)**2     
      BTOT0(2,3) = DFTOT_0(2,1)*DFTOT_0(3,1)+DFTOT_0(2,2)*DFTOT_0(3,2)
     #+DFTOT_0(2,3)
     #*DFTOT_0(3,3)     
      BTOT0(3,1) = DFTOT_0(1,1)*DFTOT_0(3,1)+DFTOT_0(1,2)*DFTOT_0(3,2)
     #+DFTOT_0(1,3)
     #*DFTOT_0(3,3)
      BTOT0(3,2) = DFTOT_0(2,1)*DFTOT_0(3,1)+DFTOT_0(2,2)*DFTOT_0(3,2)
     #+DFTOT_0(2,3)
     #*DFTOT_0(3,3)
      BTOT0(3,3) = DFTOT_0(3,1)**2+DFTOT_0(3,2)**2+DFTOT_0(3,3)**2
C
C    JACOBIAN AND DISTORTION TENSOR
C
      DET=DFGRD1(1, 1)*DFGRD1(2, 2)*DFGRD1(3, 3)
     1   -DFGRD1(1, 2)*DFGRD1(2, 1)*DFGRD1(3, 3)
      IF(NSHR.EQ.3) THEN
        DET=DET+DFGRD1(1, 2)*DFGRD1(2, 3)*DFGRD1(3, 1)
     1         +DFGRD1(1, 3)*DFGRD1(3, 2)*DFGRD1(2, 1)
     2         -DFGRD1(1, 3)*DFGRD1(3,1)*DFGRD1(2, 2)
     3         -DFGRD1(2, 3)*DFGRD1(3, 2)*DFGRD1(1, 1)
      END IF
	DJ0=Dl01*Dl02*Dl03
	DETTOT=DJ0*DET
C
C     CALCULATE DEVIATORIC LEFT CAUCHY-GREEN STRAIN AT START AND END OF INCREMENT
C
      BBTOT(1,1) = ONE/(DJ0*DET)**(2.D0/3.D0)*BTOT(1,1)
      BBTOT(1,2) = ONE/(DJ0*DET)**(2.D0/3.D0)*BTOT(1,2)
      BBTOT(1,3) = ONE/(DJ0*DET)**(2.D0/3.D0)*BTOT(1,3)
      BBTOT(2,1) = ONE/(DJ0*DET)**(2.D0/3.D0)*BTOT(2,1)
      BBTOT(2,2) = ONE/(DJ0*DET)**(2.D0/3.D0)*BTOT(2,2)
      BBTOT(2,3) = ONE/(DJ0*DET)**(2.D0/3.D0)*BTOT(2,3)
      BBTOT(3,1) = ONE/(DJ0*DET)**(2.D0/3.D0)*BTOT(3,1)
      BBTOT(3,2) = ONE/(DJ0*DET)**(2.D0/3.D0)*BTOT(3,2)
      BBTOT(3,3) = ONE/(DJ0*DET)**(2.D0/3.D0)*BTOT(3,3)
C      
      BBTOT0(1,1) = ONE/(DJ0*DET)**(2.D0/3.D0)*BTOT0(1,1)
      BBTOT0(1,2) = ONE/(DJ0*DET)**(2.D0/3.D0)*BTOT0(1,2)
      BBTOT0(1,3) = ONE/(DJ0*DET)**(2.D0/3.D0)*BTOT0(1,3)
      BBTOT0(2,1) = ONE/(DJ0*DET)**(2.D0/3.D0)*BTOT0(2,1)
      BBTOT0(2,2) = ONE/(DJ0*DET)**(2.D0/3.D0)*BTOT0(2,2)
      BBTOT0(2,3) = ONE/(DJ0*DET)**(2.D0/3.D0)*BTOT0(2,3)
      BBTOT0(3,1) = ONE/(DJ0*DET)**(2.D0/3.D0)*BTOT0(3,1)
      BBTOT0(3,2) = ONE/(DJ0*DET)**(2.D0/3.D0)*BTOT0(3,2)
      BBTOT0(3,3) = ONE/(DJ0*DET)**(2.D0/3.D0)*BTOT0(3,3)
C
C     VARIABLES
C           
      vN=DvN
      chhi=chi
      BI1=BBTOT(1,1)+BBTOT(2,2)+BBTOT(3,3)
      fvisc=(LOG(ONE-ONE/DETTOT)*DETTOT+ONE-vN+chi/DETTOT
     1       -BmukT*DETTOT)/vN
      gvisc=(LOG(ONE-ONE/DETTOT)*DETTOT+DETTOT/(DETTOT-1)-chi/DETTOT
     1       -BmukT*DETTOT)/vN
C
C     CALCULATE EQ CAUCHY-STRESS
C
      sig(1,1) = DNKT*(BTOT(1,1)+fvisc)/DETTOT
      sig(1,2) = DNKT*BTOT(1,2)/DETTOT
      sig(1,3) = DNKT*BTOT(1,3)/DETTOT
      sig(2,1) = DNKT*BTOT(2,1)/DETTOT
      sig(2,2) = DNKT*(BTOT(2,2)+fvisc)/DETTOT
      sig(2,3) = DNKT*BTOT(2,3)/DETTOT
      sig(3,1) = DNKT*BTOT(3,1)/DETTOT
      sig(3,2) = DNKT*BTOT(3,2)/DETTOT
      sig(3,3) = DNKT*(BTOT(3,3)+fvisc)/DETTOT
C 
C     DEFINE INITIAL STATE-VARIABLE, INV(Ci)
C   
      IF (KSTEP.EQ.1 .AND. KINC.EQ.1) THEN
       STATEV(4)=ONE
       STATEV(5)=ONE
       STATEV(6)=ONE
       STATEV(7)=ZERO
       STATEV(8)=ZERO
       STATEV(9)=ZERO
      END IF
C      
      CiINV0(1,1)=STATEV(4)
      CiINV0(1,2)=STATEV(7)
      CiINV0(1,3)=STATEV(8)
      CiINV0(2,1)=STATEV(7)
      CiINV0(2,2)=STATEV(5)
      CiINV0(2,3)=STATEV(9)
      CiINV0(3,1)=STATEV(8)
      CiINV0(3,2)=STATEV(9)
      CiINV0(3,3)=STATEV(6)
C     
C     CALCULATE Be, NEQ KIRCHOFF STRESS AND NEQ MATERIAL TANGENT
C 
      DTID=DTIME
        CALL BECALCMOD (DvN, DkTV, chi, BmukT, BETA,NDI,NSHR,
     1             VISCdev, VISCvol, DTID,
     1             DFTOT, CiINV0, Be, TAUNEQ, TAUVEC, DLTR, DPVEC, CALG)
C    
C
        CALL DNEQTANGENT (DETTOT, TAUVEC, DLTR, DPVEC,
     1                        CALG, TAUNEQ, DDSDDE2)
C
C     UPDATE STATE-VARIABLE
C
      CALL M33INV(Be, BeINV, FLAG)
      CiTEMP=MATMUL(BeINV,DFTOT)
      Ci=MATMUL(TRANSPOSE(DFTOT),CiTEMP)
      CALL M33INV(Ci, CiINV1, FLAG)
C     
      STATEV(4)=CiINV1(1,1)
      STATEV(5)=CiINV1(2,2)
      STATEV(6)=CiINV1(3,3)
      STATEV(7)=CiINV1(1,2)
      STATEV(8)=CiINV1(1,3)
      STATEV(9)=CiINV1(2,3)
C
C     CALCULATE NEQ CAUCHY-STRESS
C
      DO K1 = 1, 3
        DO K2 = 1, 3
            sigVISC(K1,K2)=TAUNEQ(K1,K2)/DETTOT
        END DO
      END DO
C
C
C     CALCULATE TOTAL STRESS
C
      STRESS(1) = sig(1,1)+sigVISC(1,1)
      STRESS(2) = sig(2,2)+sigVISC(2,2)
      STRESS(3) = sig(3,3)+sigVISC(3,3)
      STRESS(4) = sig(1,2)+sigVISC(1,2)
        IF(NSHR.EQ.3) THEN
      STRESS(5) = sig(1,3)+sigVISC(1,3)
      STRESS(6) = sig(2,3)+sigVISC(2,3)
        END IF
C
C     CALCULATE THE H-TENSOR ON MATRIX FORM
C
      BH(1,1) = TWO*BBTOT(1,1)
      BH(1,2) = ZERO
      BH(1,3) = ZERO
      BH(1,4) = BBTOT(1,2)
      BH(1,5) = BBTOT(1,3)
      BH(1,6) = ZERO
      BH(2,1) = ZERO
      BH(2,2) = TWO*BBTOT(2,2)
      BH(2,3) = ZERO
      BH(2,4) = BBTOT(2,1)
      BH(2,5) = ZERO
      BH(2,6) = BBTOT(2,3)
      BH(3,1) = ZERO
      BH(3,2) = ZERO
      BH(3,3) = TWO*BBTOT(3,3)
      BH(3,4) = ZERO
      BH(3,5) = BBTOT(3,1)
      BH(3,6) = BBTOT(3,2)
      BH(4,1) = BBTOT(2,1)
      BH(4,2) = BBTOT(1,2)
      BH(4,3) = ZERO
      BH(4,4) = BBTOT(2,2)/TWO+BBTOT(1,1)/TWO
      BH(4,5) = BBTOT(2,3)/TWO
      BH(4,6) = BBTOT(1,3)/TWO
      BH(5,1) = BBTOT(3,1)
      BH(5,2) = ZERO
      BH(5,3) = BBTOT(1,3)
      BH(5,4) = BBTOT(3,2)/TWO
      BH(5,5) = BBTOT(3,3)/TWO+BBTOT(1,1)/TWO
      BH(5,6) = BBTOT(1,2)/TWO
      BH(6,1) = ZERO
      BH(6,2) = BBTOT(3,2)
      BH(6,3) = BBTOT(2,3)
      BH(6,4) = BBTOT(3,1)/TWO
      BH(6,5) = BBTOT(2,1)/TWO
      BH(6,6) = BBTOT(3,3)/TWO+BBTOT(2,2)/TWO
C     
C     CALCULATE MATERIAL TANGENT
C
      DDSDDE(1,1) = DNKT*(ONE/(DETTOT)**(ONE/THREE)*BH(1,1)
     #                          +gvisc/DETTOT)+DDSDDE2(1,1)
      DDSDDE(1,2) = DNKT*(ONE/(DETTOT)**(ONE/THREE)*BH(1,2)
     #                          +gvisc/DETTOT)+DDSDDE2(1,2)
      DDSDDE(1,3) = DNKT*(ONE/(DETTOT)**(ONE/THREE)*BH(1,3)
     #                          +gvisc/DETTOT)+DDSDDE2(1,3)
      DDSDDE(1,4) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(1,4)+DDSDDE2(1,4)
      DDSDDE(2,1) = DNKT*(ONE/(DETTOT)**(ONE/THREE)*BH(2,1)
     #                          +gvisc/DETTOT)+DDSDDE2(2,1)
      DDSDDE(2,2) = DNKT*(ONE/(DETTOT)**(ONE/THREE)*BH(2,2)
     #                          +gvisc/DETTOT)+DDSDDE2(2,2)
      DDSDDE(2,3) = DNKT*(ONE/(DETTOT)**(ONE/THREE)*BH(2,3)
     #                          +gvisc/DETTOT)+DDSDDE2(2,3)
      DDSDDE(2,4) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(2,4)+DDSDDE2(2,4)
      DDSDDE(3,1) = DNKT*(ONE/(DETTOT)**(ONE/THREE)*BH(3,1)
     #                          +gvisc/DETTOT)+DDSDDE2(3,1)
      DDSDDE(3,2) = DNKT*(ONE/(DETTOT)**(ONE/THREE)*BH(3,2)
     #                          +gvisc/DETTOT)+DDSDDE2(3,2)
      DDSDDE(3,3) = DNKT*(ONE/(DETTOT)**(ONE/THREE)*BH(3,3)
     #                          +gvisc/DETTOT)+DDSDDE2(3,3)
      DDSDDE(3,4) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(3,4)+DDSDDE2(3,4)
      DDSDDE(4,1) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(4,1)+DDSDDE2(4,1)
      DDSDDE(4,2) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(4,2)+DDSDDE2(4,2)
      DDSDDE(4,3) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(4,3)+DDSDDE2(4,3)
      DDSDDE(4,4) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(4,4)+DDSDDE2(4,4)
        IF(NSHR.EQ.3) THEN 
      DDSDDE(1,5) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(1,5)+DDSDDE2(1,5)
      DDSDDE(1,6) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(1,6)+DDSDDE2(1,6)
      DDSDDE(2,5) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(2,5)+DDSDDE2(2,5)
      DDSDDE(2,6) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(2,6)+DDSDDE2(2,6)
      DDSDDE(3,5) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(3,5)+DDSDDE2(3,5)
      DDSDDE(3,6) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(3,6)+DDSDDE2(3,6)
      DDSDDE(4,5) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(4,5)+DDSDDE2(4,5)
      DDSDDE(4,6) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(4,6)+DDSDDE2(4,6)
      DDSDDE(5,1) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(5,1)+DDSDDE2(5,1)
      DDSDDE(5,2) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(5,2)+DDSDDE2(5,2)
      DDSDDE(5,3) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(5,3)+DDSDDE2(5,3)
      DDSDDE(5,4) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(5,4)+DDSDDE2(5,4)
      DDSDDE(5,5) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(5,5)+DDSDDE2(5,5)
      DDSDDE(5,6) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(5,6)+DDSDDE2(5,6)
      DDSDDE(6,1) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(6,1)+DDSDDE2(6,1)
      DDSDDE(6,2) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(6,2)+DDSDDE2(6,2)
      DDSDDE(6,3) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(6,3)+DDSDDE2(6,3)
      DDSDDE(6,4) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(6,4)+DDSDDE2(6,4)
      DDSDDE(6,5) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(6,5)+DDSDDE2(6,5)
      DDSDDE(6,6) = DNKT*ONE/(DETTOT)**(ONE/THREE)*BH(6,6)+DDSDDE2(6,6)
        END IF
C
C     SAVE INITIAL SWELLING VALUES
C     
      STATEV(1)=Dl01
      STATEV(2)=Dl02
      STATEV(3)=Dl03
C
C     STORED OUTPUT DATA
C
      STATEV(10)=DET
      STATEV(11)=STRESS(2)
      STATEV(12)=STRESS(2)-sigVISC(2,2)
      STATEV(13)=sigVISC(2,2)
      STATEV(14)=DFTOT(2,2)
      STATEV(15)=DFTOT(1,1)
      STATEV(16)=Be(2,2)
      STATEV(17)=Be(1,1)
      STATEV(18)=-LOG(DFGRD1(1,1))/LOG(DFGRD1(2,2))
C	
      RETURN
      END
      
      
      SUBROUTINE USDFLD(FIELD,STATEV,PNEWDT,DIRECT,T,CELENT,
     1 TIME,DTIME,CMNAME,ORNAME,NFIELD,NSTATV,NOEL,NPT,LAYER,
     2 KSPT,KSTEP,KINC,NDI,NSHR,COORD,JMAC,JMATYP,MATLAYO,LACCFLA)
C
      INCLUDE 'ABA_PARAM.INC'
C
      CHARACTER*80 CMNAME,ORNAME
      CHARACTER*3  FLGRAY(15)
      DIMENSION FIELD(NFIELD),STATEV(NSTATV),DIRECT(3,3),
     1 T(3,3),TIME(2)
      DIMENSION ARRAY(15),JARRAY(15),JMAC(*),JMATYP(*),COORD(*)


C      user coding to define FIELD and, if necessary, STATEV and PNEWDT

      
      CALL GETVRM('DGP',ARRAY,JARRAY,FLGRAY,JRCD,JMAC,JMATYP,MATLAYO,
     1 LACCFLA)
c cccccc invariants cccccccccccccccccccccc     
      DETTOT=(ARRAY(2)*ARRAY(3)*ARRAY(1)*1.5**3.)
      BI1=((1.5*ARRAY(1))**2.+(1.5*ARRAY(2))**2.+(1.5*ARRAY(3))**2.)
     #*DETTOT**(-2.0/3.0)
cccccccccccccccccccc delta_BI1/delat_t cccccccccccccccc
      if (KSTEP.EQ.1) then
           if (KINC.EQ.1) then
           delta_BI1=0.
           else
           delta_BI1=BI1-statev(3)
           endif 
        else
        delta_BI1=BI1-statev(3)
       endif     
      statev(3)=BI1

ccccccc properties ccccccccccccccccccccccc
      vN=0.001
      chhi=0.1
ccccccc DCDmu,BI1,bsig ccccccccccccccccccccccc 
      t0=-9*DETTOT**(10.D0/3.D0)*(DETTOT-1)/(9*vN*DETTOT**(4.D0/3.D0)+
     #vN*BI1*DETTOT**3-vN*BI1*DETTOT**2-9*vN*DETTOT**(7.D0/3.D0)+18*chhi
     #*DETTOT**(4.D0/3.D0)-9*DETTOT**(4.D0/3.D0)-18*chhi*DETTOT**(1.D0/3
     #.D0))
      
      DCDmu=t0
      FIELD(3)=DCDmu
       statev(10)=DCDmu 
c     the density      
      FIELD(1)=1./(ARRAY(2)*ARRAY(3)*ARRAY(1)*1.5**3)
c      WRITE(6,*) 'field1',FIELD(1)
cccccccccccccccccccccccccccc
      
c the conductivity ccccccccc      
      FIELD(2)=(DETTOT-1.)/DETTOT*8e-10
      STATEV(9)=1./(ARRAY(2)*ARRAY(3)*ARRAY(1)*1.5**3)
cccccccccccccccccccc delta_BI1/delat_t cccccccccccccccc
      CALL GETVRM('SP',ARRAY,JARRAY,FLGRAY,JRCD,JMAC,JMATYP,MATLAYO,
     1 LACCFLA)
     
      bsig=ARRAY(1)+ARRAY(2)+ARRAY(3)
      if (KSTEP.EQ.1) then
            if (KINC.EQ.1) then
           delta_bsig=bsig-0.0
            else
            delta_bsig=bsig-statev(4)
            endif  
        else 
        delta_bsig=bsig-statev(4)
      endif   
      statev(4)=bsig      
      
ccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccc calculate internal heat cccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      t1=3*vN*DETTOT**3*(DETTOT-1)/(9*vN*DETTOT**(4.D0/3.D0)+vN*BI1*DE
     #TTOT**3-vN*BI1*DETTOT**2-9*vN*DETTOT**(7.D0/3.D0)+18*chhi*DETTOT**
     #(4.D0/3.D0)-9*DETTOT**(4.D0/3.D0)-18*chhi*DETTOT**(1.D0/3.D0))
      
      DCDBI1=t1
      statev(5)=DCDBI1
      
      t2 = -3*DETTOT**(10.D0/3.D0)*(DETTOT-1)/(9*vN*DETTOT**(4.D0/3.D0)+
     #vN*BI1*DETTOT**3-vN*BI1*DETTOT**2-9*vN*DETTOT**(7.D0/3.D0)+18*chhi
     #*DETTOT**(4.D0/3.D0)-9*DETTOT**(4.D0/3.D0)-18*chhi*DETTOT**(1.D0/3
     #.D0))
     
      DCDbsig=t2
      statev(6)=DCDbsig 
      
      r=-1./DETTOT*(DCDBI1*delta_BI1/DTIME+DCDbsig*delta_bsig/DTIME)
      statev(7)=r    

      

      
      RETURN
      END
	
      SUBROUTINE HETVAL(CMNAME,TEMP,TIME,DTIME,STATEV,FLUX,
     1 PREDEF,DPRED)
C
      INCLUDE 'ABA_PARAM.INC'
C
      CHARACTER*80 CMNAME
C
      DIMENSION TEMP(2),STATEV(*),PREDEF(*),TIME(2),FLUX(2),
     1 DPRED(*)


c      user coding to define FLUX and update STATEV
      
      FLUX(1)=statev(7)
c      if (TIME(2).LE.50.) then
c      FLUX(1)=0.0
c      endif
c      WRITE(6,*) 'flux', FLUX(1),TIME(1)
      RETURN
      END
      
!***********************************************************************************************************************************
!  DJ0calc  -  CALCULATE J_0
!
!  vN, chi, DmukT = input vaiables
!  DJ0            = output variable
!***********************************************************************************************************************************

      SUBROUTINE DJ0calc (vN, chi, DmukT, DJ0)

      IMPLICIT NONE

      DOUBLE PRECISION, INTENT(IN) :: vN
      DOUBLE PRECISION, INTENT(IN) :: chi
      DOUBLE PRECISION, INTENT(IN) :: DmukT

      DOUBLE PRECISION, PARAMETER :: VARTEST = 1.0D-8
      DOUBLE PRECISION, INTENT(OUT) :: DJ0
      DOUBLE PRECISION :: VAR0
      DOUBLE PRECISION :: VAR1
      DOUBLE PRECISION :: F
      DOUBLE PRECISION :: DF
      integer :: K1

      VAR0=1.5D0
      do K1=1,25,1
        F=vN*VAR0**(-1.D0/3.D0)
     1   + (log(1.D0-1.D0/VAR0)+(1.D0-vN)/VAR0+chi/(VAR0**2.D0)-DmukT)
        DF=-(vN/3.D0)*VAR0**(-4.D0/3.D0)-(1.D0-vN)/(VAR0**2.D0)
     1   - 2.D0*chi/(VAR0**3.D0)+1.D0/(VAR0**2.D0-VAR0)
     
      VAR1=VAR0-F/DF

        IF (ABS(VAR1-VAR0) .LE. VARTEST) THEN
            DJ0 = VAR1
            RETURN
        END IF
       VAR0=VAR1
       
      END DO

      RETURN

      END SUBROUTINE DJ0calc
      
!***********************************************************************************************************************************
!  BECALCMOD -  CALCULATE ELASTIC LEFT CAUCHY STRAIN AND NEQ-KIRCHOFF STRESS
!  
!  INPUT VARIABLES:
!  DFGRD = DEFORMATION GRADIENT OF STEP K
!  CiINV = INVERSE INELASTIC (VISCOUS) RIGHT CAUCHY-GREEN STRAIN TENSOR AT STEP K-1
!  TAU   = KIRCHOFF STRESS AT STEP K+1
!  MATERIALPARAMETERS = DvN, DkTV, DmukT, BETA, VISCdev, VISCvol
!     DvN:=vN DkTV:=KT/v
!  
!  OUTPUT VARIABLES:
!  Be = ELASTIC LEFT CAUCHY STRAIN
!  TAUNEQ = NEQ-KIRCHOFF STRESS
!     Output values for the calculation of the NEQ-tangent modulus:
!  TAUVEC = Principal values of the NEQ-KIRCHOFF STRESS on vector form
!  DLTR   = Principal values of Be^tr (start of iteration)
!  DPVEC  = Principal directions of Be (assumed similar to those of Be^tr)
!  Calg   = Algorithmic tangent modulus
!***********************************************************************************************************************************
C
      SUBROUTINE BECALCMOD (DvN, DkTV, CHI, DMUKT, BETA,NDI,NSHR,
     1                   VISCdev, VISCvol, DTIME,
     1                   DFGRD, CiINV, 
     1                   Be, TAUNEQ, TAUVEC, DLTR, DPVEC, CALG)

      IMPLICIT NONE

      DOUBLE PRECISION, INTENT(IN) :: DvN
      DOUBLE PRECISION, INTENT(IN) :: DkTV
      DOUBLE PRECISION, INTENT(IN) :: CHI
      DOUBLE PRECISION, INTENT(IN) :: DMUKT
      DOUBLE PRECISION, INTENT(IN) :: BETA
      DOUBLE PRECISION, INTENT(IN) :: NDI
      DOUBLE PRECISION, INTENT(IN) :: NSHR
      DOUBLE PRECISION, INTENT(IN) :: VISCdev
      DOUBLE PRECISION, INTENT(IN) :: VISCvol
      DOUBLE PRECISION, INTENT(IN) :: DTIME
C      
      DOUBLE PRECISION, DIMENSION(3,3), INTENT(IN) :: DFGRD
      DOUBLE PRECISION, DIMENSION(3,3), INTENT(IN) :: CiINV
C
      DOUBLE PRECISION, DIMENSION(3,3), INTENT(OUT) :: Be
      DOUBLE PRECISION, DIMENSION(3,3), INTENT(OUT) :: TAUNEQ
      DOUBLE PRECISION, DIMENSION(3), INTENT(OUT) :: TAUVEC
      DOUBLE PRECISION, DIMENSION(3), INTENT(OUT) :: DLTR
      DOUBLE PRECISION, DIMENSION(3,3), INTENT(OUT) :: DPVEC
      DOUBLE PRECISION, DIMENSION(3,3), INTENT(OUT) :: CALG
C
      DOUBLE PRECISION, PARAMETER :: TOL = 1.0D-12
C     
      DOUBLE PRECISION, DIMENSION(3,3) :: BeTEMP
      DOUBLE PRECISION, DIMENSION(3,3) :: BeTRIAL
      DOUBLE PRECISION, DIMENSION(6) :: BeTR_
      DOUBLE PRECISION, DIMENSION(6) :: Be2_
C
      DOUBLE PRECISION, DIMENSION(3) :: PV
      DOUBLE PRECISION, DIMENSION(3,3) :: PD
      DOUBLE PRECISION, DIMENSION(3) :: PV2
      DOUBLE PRECISION, DIMENSION(3,3) :: PD2
C
      DOUBLE PRECISION :: dNKT
      DOUBLE PRECISION :: V1
      DOUBLE PRECISION :: V2
      DOUBLE PRECISION :: TR3
      DOUBLE PRECISION :: DEV1
      DOUBLE PRECISION :: DEV2
      DOUBLE PRECISION :: DEV3
      DOUBLE PRECISION, DIMENSION(3) :: Q0
      DOUBLE PRECISION, DIMENSION(3) :: Q1
      DOUBLE PRECISION, DIMENSION(3) :: E0
      DOUBLE PRECISION, DIMENSION(3) :: E1
      DOUBLE PRECISION, DIMENSION(3) :: DE
      DOUBLE PRECISION, DIMENSION(3) :: ETRIAL
C
      DOUBLE PRECISION, DIMENSION(3,3) :: DK
      DOUBLE PRECISION, DIMENSION(3,3) :: DKINV
      DOUBLE PRECISION, DIMENSION(3) :: VR
      DOUBLE PRECISION, DIMENSION(3,3) :: DTDEPS
C
      integer :: K1
      integer :: K2
      integer :: K3
      DOUBLE PRECISION :: DnormDE
      DOUBLE PRECISION :: DnormBE
      DOUBLE PRECISION :: f
      DOUBLE PRECISION :: g
      DOUBLE PRECISION :: DETE
      LOGICAL :: FLAG
C
C
C
C      
      BeTEMP = MATMUL(CiINV,TRANSPOSE(DFGRD))
      BeTRIAL = MATMUL(DFGRD,BeTEMP)
      BeTR_(1) = BeTRIAL(1,1)
      BeTR_(2) = BeTRIAL(2,2)
      BeTR_(3) = BeTRIAL(3,3)
      BeTR_(4) = BeTRIAL(1,2)+BeTRIAL(2,1)
      BeTR_(5) = BeTRIAL(1,3)+BeTRIAL(3,1)
      BeTR_(6) = BeTRIAL(2,3)+BeTRIAL(3,2)
C
      CALL SPRIND(BeTR_,PV,PD,2,NDI,NSHR)
C     
      V1=DTIME*BETA*1.D0/(2.D0*VISCdev)
      V2=DTIME*BETA*1.D0/(3.D0*VISCvol)
      dNKT=DvN*DkTV
C     
      Q0(1)=PV(1)
      Q0(2)=PV(2)
      Q0(3)=PV(3)
      ETRIAL(1)=1.D0/2.D0*LOG(PV(1))
      ETRIAL(2)=1.D0/2.D0*LOG(PV(2))
      ETRIAL(3)=1.D0/2.D0*LOG(PV(3))
C
      do K3=1,175,1
C
CCC   Explanation of the variables
CCC   DETE:=Je CC Q0(A):=Lambda^2_A CC DEVA:=dev(Be_A)
CCC   TR3:=tr(Be)/3 CC f:=f(y) CC g:=g(y)
CCC   ETRIAL(A):=epsilon^tr_Ae CC E0(A):=epsilon_Ae at step k
C   
        DETE=(Q0(1)*Q0(2)*Q0(3))**(1.0D0/2.0D0)
        TR3=(Q0(1)+Q0(2)+Q0(3))/3.D0
        DEV1=(2.D0*Q0(1)-Q0(2)-Q0(3))/3.D0
        DEV2=(2.D0*Q0(2)-Q0(1)-Q0(3))/3.D0
        DEV3=(2.D0*Q0(3)-Q0(1)-Q0(2))/3.D0
        f=(LOG(1.0D0-1.0D0/DETE)*DETE+
     1     1.0D0-DvN+CHI/DETE-DMUKT*DETE)/DvN
        g=(LOG(1.0D0-1.0D0/DETE)*DETE+
     1     DETE/(DETE-1.0D0)-CHI/DETE-DMUKT*DETE)/DvN
        E0(1)=1.D0/2.D0*LOG(Q0(1))
        E0(2)=1.D0/2.D0*LOG(Q0(2))
        E0(3)=1.D0/2.D0*LOG(Q0(3))
C        
        DK(1,1)=1.D0+dNKT*( V1*4.D0/3.D0*Q0(1)+V2*(2.D0/9.D0*Q0(1)+g) )
        DK(1,2)=dNKT*( V1*-2.D0/3.D0*Q0(2)+V2*(2.D0/9.D0*Q0(2)+g) )
        DK(1,3)=dNKT*( V1*-2.D0/3.D0*Q0(3)+V2*(2.D0/9.D0*Q0(3)+g) )
        DK(2,1)=dNKT*( V1*-2.D0/3.D0*Q0(1)+V2*(2.D0/9.D0*Q0(1)+g) )
        DK(2,2)=1.D0+dNKT*( V1*4.D0/3.D0*Q0(2)+V2*(2.D0/9.D0*Q0(2)+g) )
        DK(2,3)=dNKT*( V1*-2.D0/3.D0*Q0(3)+V2*(2.D0/9.D0*Q0(3)+g) )
        DK(3,1)=dNKT*( V1*-2.D0/3.D0*Q0(1)+V2*(2.D0/9.D0*Q0(1)+g) )
        DK(3,2)=dNKT*( V1*-2.D0/3.D0*Q0(2)+V2*(2.D0/9.D0*Q0(2)+g) )
        DK(3,3)=1.D0+dNKT*( V1*4.D0/3.D0*Q0(3)+V2*(2.D0/9.D0*Q0(3)+g) )
C       
        VR(1)=dNKT*( V1*DEV1 +V2*(TR3+f) )+E0(1)-ETRIAL(1)
        VR(2)=dNKT*( V1*DEV2 +V2*(TR3+f) )+E0(2)-ETRIAL(2)
        VR(3)=dNKT*( V1*DEV3 +V2*(TR3+f) )+E0(3)-ETRIAL(3)
C       
        CALL M33INV(DK, DKINV, FLAG)
        DE(1)=-(DKINV(1,1)*VR(1)+DKINV(1,2)*VR(2)+DKINV(1,3)*VR(3))
        DE(2)=-(DKINV(2,1)*VR(1)+DKINV(2,2)*VR(2)+DKINV(2,3)*VR(3))
        DE(3)=-(DKINV(3,1)*VR(1)+DKINV(3,2)*VR(2)+DKINV(3,3)*VR(3))
C       
        E1(1)=E0(1)+DE(1)
        E1(2)=E0(2)+DE(2)
        E1(3)=E0(3)+DE(3)
C
        DnormDE=(DE(1)**2.D0+DE(2)**2.D0+DE(3)**2.D0)**(1.D0/2.D0)
        if (abs(DnormDE).LT.TOL) then 
            DO K1 = 1, 3
                DO K2 = 1, 3
                    Be(K2,K1)=Q0(1)*PD(1,K2)*PD(1,K1)
     1                       +Q0(2)*PD(2,K2)*PD(2,K1)
     1                       +Q0(3)*PD(3,K2)*PD(3,K1)
                END DO
            END DO
            TAUNEQ(1,1)=BETA*dNKT*(Be(1,1)+f)
            TAUNEQ(2,2)=BETA*dNKT*(Be(2,2)+f)
            TAUNEQ(3,3)=BETA*dNKT*(Be(3,3)+f)
            TAUNEQ(1,2)=BETA*dNKT*Be(1,2)
            TAUNEQ(1,3)=BETA*dNKT*Be(1,3)
            TAUNEQ(2,3)=BETA*dNKT*Be(2,3)
            TAUNEQ(2,1)=BETA*dNKT*Be(2,1)
            TAUNEQ(3,1)=BETA*dNKT*Be(3,1)
            TAUNEQ(3,2)=BETA*dNKT*Be(3,2)
            TAUVEC(1)=BETA*dNKT*(Q0(1)+f)
            TAUVEC(2)=BETA*dNKT*(Q0(2)+f)
            TAUVEC(3)=BETA*dNKT*(Q0(3)+f)
            DLTR(1)=EXP(2.0D0*ETRIAL(1))
            DLTR(2)=EXP(2.0D0*ETRIAL(2))
            DLTR(3)=EXP(2.0D0*ETRIAL(3))
            DO K1 = 1, 3
                DO K2 = 1, 3
                    DPVEC(K2,K1)=PD(K2,K1)
                END DO
            END DO
            DTDEPS(1,1)=BETA*dNKT*(2.0D0*Q0(1)+g)
            DTDEPS(2,2)=BETA*dNKT*(2.0D0*Q0(2)+g)
            DTDEPS(3,3)=BETA*dNKT*(2.0D0*Q0(3)+g)
            DTDEPS(1,2)=BETA*dNKT*g
            DTDEPS(1,3)=BETA*dNKT*g
            DTDEPS(2,3)=BETA*dNKT*g
            DTDEPS(2,1)=BETA*dNKT*g
            DTDEPS(3,1)=BETA*dNKT*g
            DTDEPS(3,2)=BETA*dNKT*g
            CALG = MATMUL(DTDEPS,DKINV)
            return
        end if 
C     
      Q1(1)=EXP(2.D0*E1(1))
      Q1(2)=EXP(2.D0*E1(2))
      Q1(3)=EXP(2.D0*E1(3))
      Q0(1)=Q1(1)
      Q0(2)=Q1(2)
      Q0(3)=Q1(3)
C        
      END DO
C
      RETURN
C
      END SUBROUTINE BECALCMOD
      

!***********************************************************************************************************************************
!  M33INV  -  Compute the inverse of a 3x3 matrix.
!
!  A       = input 3x3 matrix to be inverted
!  AINV    = output 3x3 inverse of matrix A
!  OK_FLAG = (output) .TRUE. if the input matrix could be inverted, and .FALSE. if the input matrix is singular.
!  Code written by:   David G. Simpson  -   NASA Goddard Space Flight Center
!***********************************************************************************************************************************

      SUBROUTINE M33INV (A, AINV, OK_FLAG)

      IMPLICIT NONE

      DOUBLE PRECISION, DIMENSION(3,3), INTENT(IN)  :: A
      DOUBLE PRECISION, DIMENSION(3,3), INTENT(OUT) :: AINV
      LOGICAL, INTENT(OUT) :: OK_FLAG

      DOUBLE PRECISION, PARAMETER :: EPS = 1.0D-16
      DOUBLE PRECISION :: DET
      DOUBLE PRECISION, DIMENSION(3,3) :: COFACTOR


      DET =   A(1,1)*A(2,2)*A(3,3)  
     1       - A(1,1)*A(2,3)*A(3,2)  
     1       - A(1,2)*A(2,1)*A(3,3)  
     1       + A(1,2)*A(2,3)*A(3,1)  
     1       + A(1,3)*A(2,1)*A(3,2)  
     1       - A(1,3)*A(2,2)*A(3,1)

      IF (ABS(DET) .LE. EPS) THEN
         AINV = 0.0D0
         OK_FLAG = .FALSE.
         RETURN
      END IF

      COFACTOR(1,1) = +(A(2,2)*A(3,3)-A(2,3)*A(3,2))
      COFACTOR(1,2) = -(A(2,1)*A(3,3)-A(2,3)*A(3,1))
      COFACTOR(1,3) = +(A(2,1)*A(3,2)-A(2,2)*A(3,1))
      COFACTOR(2,1) = -(A(1,2)*A(3,3)-A(1,3)*A(3,2))
      COFACTOR(2,2) = +(A(1,1)*A(3,3)-A(1,3)*A(3,1))
      COFACTOR(2,3) = -(A(1,1)*A(3,2)-A(1,2)*A(3,1))
      COFACTOR(3,1) = +(A(1,2)*A(2,3)-A(1,3)*A(2,2))
      COFACTOR(3,2) = -(A(1,1)*A(2,3)-A(1,3)*A(2,1))
      COFACTOR(3,3) = +(A(1,1)*A(2,2)-A(1,2)*A(2,1))

      AINV = TRANSPOSE(COFACTOR) / DET

      OK_FLAG = .TRUE.

      RETURN

      END SUBROUTINE M33INV
      

      
      
!***********************************************************************************************************************************
!  DNEQ -  CALCULATE NEQ TANGENT
!  
!  INPUT VARIABLES:
!  DET      =   DETERMINANT OF DEFORMATION GRADIENT
!  TAUVEC   =   VECTOR CONTAINING THE PRINCIPAL KIRCHOFF-STRESSES
!  DLTR     =   VECTOR CONTAINING THE SQUARED PRINCIPAL TRIAL-STRAINS
!  DPVEC    =   MATRIX CONTAINING THE THREE PRINCIPAL DIRECTIONS OF Be
!  CALG     =   ALGORITMIC MODULUS (3,3)
!  TAUNEQ   =   INELASTIC KIRCHOFF STRESS (3,3)
!  
!  OUTPUT VARIABLES:
!  DDSDDE = NEQ MATERIAL-TANGENT (6,6)
!***********************************************************************************************************************************

      SUBROUTINE DNEQTANGENT (DET, TAUVEC, DLTR, DPVEC,
     1                        CALG, TAUNEQ, DDSDDE)
C
      IMPLICIT NONE
C
      DOUBLE PRECISION, INTENT(IN) :: DET
      DOUBLE PRECISION, DIMENSION(3), INTENT(IN) :: TAUVEC
      DOUBLE PRECISION, DIMENSION(3), INTENT(IN) :: DLTR
C      
      DOUBLE PRECISION, DIMENSION(3,3), INTENT(IN) :: DPVEC
      DOUBLE PRECISION, DIMENSION(3,3), INTENT(IN) :: CALG
      DOUBLE PRECISION, DIMENSION(3,3), INTENT(IN) :: TAUNEQ
C
      DOUBLE PRECISION, DIMENSION(6,6), INTENT(OUT) :: DDSDDE
C     
      DOUBLE PRECISION, DIMENSION(3,3,3,3) :: DDSDDETEMP
C
      DOUBLE PRECISION, PARAMETER :: eps = 1.0D-10
C
      integer :: K1
      integer :: K2
      integer :: K3
      integer :: K4
      DOUBLE PRECISION :: VAR1
      DOUBLE PRECISION :: VAR2
      DOUBLE PRECISION :: VAR3
C
      IF (ABS(DLTR(2)-DLTR(1)).LT.eps) THEN
      VAR1 = 0.0D0
      ELSE
      VAR1 = 1.0D0*(TAUVEC(2)*DLTR(1)-TAUVEC(1)*DLTR(2))
     1              /(DLTR(2)-DLTR(1))
      END IF
C
      IF (ABS(DLTR(3)-DLTR(1)).LT.eps) THEN
      VAR2 = 0.0D0
      ELSE
      VAR2 = 1.0D0*(TAUVEC(3)*DLTR(1)-TAUVEC(1)*DLTR(3))
     1              /(DLTR(3)-DLTR(1))
      END IF
C
      IF (ABS(DLTR(3)-DLTR(2)).LT.eps) THEN
      VAR3 = 0.0D0
      ELSE
      VAR3 = 1.0D0*(TAUVEC(3)*DLTR(2)-TAUVEC(2)*DLTR(3))
     1              /(DLTR(3)-DLTR(2))
      END IF
C
      DO K1 = 1, 3
        DO K2 = 1, 3
          DO K3 = 1, 3
            DO K4 = 1, 3
                DDSDDETEMP(K1,K2,K3,K4) =
     1   ( CALG(1,1)-2.0D0*TAUVEC(1) )
     1 *DPVEC(1,K1)*DPVEC(1,K2)*DPVEC(1,K3)*DPVEC(1,K4)
     1  +( CALG(2,2)-2.0D0*TAUVEC(2) )
     1 *DPVEC(2,K1)*DPVEC(2,K2)*DPVEC(2,K3)*DPVEC(2,K4)
     1  +( CALG(3,3)-2.0D0*TAUVEC(3) )
     1 *DPVEC(3,K1)*DPVEC(3,K2)*DPVEC(3,K3)*DPVEC(3,K4)
     1  +CALG(1,2)*DPVEC(1,K1)*DPVEC(1,K2)*DPVEC(2,K3)*DPVEC(2,K4)
     1  +CALG(1,3)*DPVEC(1,K1)*DPVEC(1,K2)*DPVEC(3,K3)*DPVEC(3,K4)
     1  +CALG(2,3)*DPVEC(2,K1)*DPVEC(2,K2)*DPVEC(3,K3)*DPVEC(3,K4)
     1  +CALG(2,1)*DPVEC(2,K1)*DPVEC(2,K2)*DPVEC(1,K3)*DPVEC(1,K4)
     1  +CALG(3,1)*DPVEC(3,K1)*DPVEC(3,K2)*DPVEC(1,K3)*DPVEC(1,K4)
     1  +CALG(3,2)*DPVEC(3,K1)*DPVEC(3,K2)*DPVEC(2,K3)*DPVEC(2,K4)
     1  +VAR1*DPVEC(1,K1)*DPVEC(2,K2)*DPVEC(1,K3)*DPVEC(2,K4)
     1  +VAR1*DPVEC(2,K1)*DPVEC(1,K2)*DPVEC(2,K3)*DPVEC(1,K4)
     1  +VAR1*DPVEC(1,K1)*DPVEC(2,K2)*DPVEC(2,K3)*DPVEC(1,K4)
     1  +VAR1*DPVEC(2,K1)*DPVEC(1,K2)*DPVEC(1,K3)*DPVEC(2,K4)
     1  +VAR2*DPVEC(1,K1)*DPVEC(3,K2)*DPVEC(1,K3)*DPVEC(3,K4)
     1  +VAR2*DPVEC(3,K1)*DPVEC(1,K2)*DPVEC(3,K3)*DPVEC(1,K4)
     1  +VAR2*DPVEC(1,K1)*DPVEC(3,K2)*DPVEC(3,K3)*DPVEC(1,K4)
     1  +VAR2*DPVEC(3,K1)*DPVEC(1,K2)*DPVEC(1,K3)*DPVEC(3,K4)
     1  +VAR3*DPVEC(2,K1)*DPVEC(3,K2)*DPVEC(2,K3)*DPVEC(3,K4)
     1  +VAR3*DPVEC(3,K1)*DPVEC(2,K2)*DPVEC(3,K3)*DPVEC(2,K4)
     1  +VAR3*DPVEC(2,K1)*DPVEC(3,K2)*DPVEC(3,K3)*DPVEC(2,K4)
     1  +VAR3*DPVEC(3,K1)*DPVEC(2,K2)*DPVEC(2,K3)*DPVEC(3,K4)
            END DO
          END DO
        END DO
      END DO
C
      DDSDDE(1,1)=DDSDDETEMP(1,1,1,1)/DET+2.0D0*TAUNEQ(1,1)/DET
      DDSDDE(2,1)=DDSDDETEMP(2,2,1,1)/DET
      DDSDDE(3,1)=DDSDDETEMP(3,3,1,1)/DET
      DDSDDE(4,1)=DDSDDETEMP(1,2,1,1)/DET+TAUNEQ(2,1)/DET
      DDSDDE(5,1)=DDSDDETEMP(1,3,1,1)/DET+TAUNEQ(3,1)/DET
      DDSDDE(6,1)=DDSDDETEMP(2,3,1,1)/DET
C
      DDSDDE(1,2)=DDSDDETEMP(1,1,2,2)/DET
      DDSDDE(2,2)=DDSDDETEMP(2,2,2,2)/DET+2.0D0*TAUNEQ(2,2)/DET
      DDSDDE(3,2)=DDSDDETEMP(3,3,2,2)/DET
      DDSDDE(4,2)=DDSDDETEMP(1,2,2,2)/DET+TAUNEQ(1,2)/DET
      DDSDDE(5,2)=DDSDDETEMP(1,3,2,2)/DET
      DDSDDE(6,2)=DDSDDETEMP(2,3,2,2)/DET+TAUNEQ(3,2)/DET
C
      DDSDDE(1,3)=DDSDDETEMP(1,1,3,3)/DET
      DDSDDE(2,3)=DDSDDETEMP(2,2,3,3)/DET
      DDSDDE(3,3)=DDSDDETEMP(3,3,3,3)/DET+2.0D0*TAUNEQ(3,3)/DET
      DDSDDE(4,3)=DDSDDETEMP(1,2,3,3)/DET
      DDSDDE(5,3)=DDSDDETEMP(1,3,3,3)/DET+TAUNEQ(1,3)/DET
      DDSDDE(6,3)=DDSDDETEMP(2,3,3,3)/DET+TAUNEQ(2,3)/DET
C
      DDSDDE(1,4)=DDSDDETEMP(1,1,1,2)/DET+TAUNEQ(1,2)/DET
      DDSDDE(2,4)=DDSDDETEMP(2,2,1,2)/DET+TAUNEQ(2,1)/DET
      DDSDDE(3,4)=DDSDDETEMP(3,3,1,2)/DET
      DDSDDE(4,4)=DDSDDETEMP(1,2,1,2)/DET
     1           +0.5D0*(TAUNEQ(1,1)+TAUNEQ(2,2))/DET
      DDSDDE(5,4)=DDSDDETEMP(1,3,1,2)/DET+0.5D0*TAUNEQ(3,2)/DET
      DDSDDE(6,4)=DDSDDETEMP(2,3,1,2)/DET+0.5D0*TAUNEQ(3,1)/DET
C
      DDSDDE(1,5)=DDSDDETEMP(1,1,1,3)/DET+TAUNEQ(1,3)/DET
      DDSDDE(2,5)=DDSDDETEMP(2,2,1,3)/DET
      DDSDDE(3,5)=DDSDDETEMP(3,3,1,3)/DET+TAUNEQ(3,1)/DET
      DDSDDE(4,5)=DDSDDETEMP(1,2,1,3)/DET+0.5D0*TAUNEQ(2,3)/DET
      DDSDDE(5,5)=DDSDDETEMP(1,3,1,3)/DET
     1           +0.5D0*(TAUNEQ(1,1)+TAUNEQ(3,3))/DET
      DDSDDE(6,5)=DDSDDETEMP(2,3,1,3)/DET+0.5D0*TAUNEQ(2,1)/DET
C
      DDSDDE(1,6)=DDSDDETEMP(1,1,2,3)/DET
      DDSDDE(2,6)=DDSDDETEMP(2,2,2,3)/DET+TAUNEQ(2,3)/DET
      DDSDDE(3,6)=DDSDDETEMP(3,3,2,3)/DET+TAUNEQ(3,2)/DET
      DDSDDE(4,6)=DDSDDETEMP(1,2,2,3)/DET+0.5D0*TAUNEQ(1,3)/DET
      DDSDDE(5,6)=DDSDDETEMP(1,3,2,3)/DET+0.5D0*TAUNEQ(1,2)/DET
      DDSDDE(6,6)=DDSDDETEMP(2,3,2,3)/DET
     1           +0.5D0*(TAUNEQ(2,2)+TAUNEQ(3,3))/DET
C
      RETURN
C
      END SUBROUTINE DNEQTANGENT